package com.example.demo1.utils;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;


public class DateUtil {


    public static Date parse(String dataStr){
    	return parse(dataStr,null);
    }

	public static Date parse(String dateStr,String pattern) {
		if(dateStr==null||dateStr.length()==0){
			return null;
		}
	try{
		SimpleDateFormat df=new SimpleDateFormat("yyyy-MM-dd");//SimpleDateFormat非线程安全，每次使用时创建实例
		if(pattern!=null){
			df.applyPattern(pattern);
		}
		else{
			if(dateStr.length()>10){//yyyy-MM-dd HH:mm:ss
				df.applyPattern("yyyy-MM-dd HH:mm:ss");
			}
			else{
				df.applyPattern("yyyy-MM-dd");
			}
		}

		   return df.parse(dateStr);
		}
		catch(ParseException pe){
			pe.printStackTrace();
			return null;
		}

	}

	public static String format(Date date,String pattern){
		if(date==null){
			return null;
		}
		if(pattern==null||pattern.length()==0){
			pattern="yyyy-MM-dd";
		}
		SimpleDateFormat df=new SimpleDateFormat("yyyy-MM-dd");
		df.applyPattern(pattern);
		return df.format(date);
	}

	public static void main(String[] args) throws Exception{
		String d="2011-09-01";
		Date dd=DateUtil.parse(d, null);
		System.out.println(dd.getTime());
	}

}
