package com.example.demo1.utils;

import cn.hutool.core.convert.Convert;
import cn.hutool.core.util.StrUtil;
import com.alibaba.fastjson.JSONObject;

import com.example.demo1.config.OSSConfig;
import com.example.demo1.dto.Timeval;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.ValueOperations;
import org.springframework.stereotype.Component;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Locale;
import java.util.concurrent.CompletableFuture;
import java.util.concurrent.TimeUnit;

/**
 * @author 墨鱼_mo
 * @date 2022/6/1 0001 上午 10:24
 */
@Component
@Slf4j
public final class StringUtils extends StrUtil {

    @Autowired
    private OSSConfig ossConfig;



    @Autowired
    private ValueOperations<String, Object> valueOperations;



    /**
     * 获取停车数据的时间
     *
     * @param timeval
     * @return
     */
    public static String getAlarmInfoPlateTimeStr(Timeval timeval) {

        String year = Convert.toStr(timeval.getDecyear());
        String month = setTimeStr(Convert.toStr(timeval.getDecmon()));
        String day = setTimeStr(Convert.toStr(timeval.getDecday()));
        String hour = setTimeStr(Convert.toStr(timeval.getDechour()));
        String min = setTimeStr(Convert.toStr(timeval.getDecmin()));
        String sec = setTimeStr(Convert.toStr(timeval.getDecsec()));

        return StringUtils.format("{}-{}-{} {}:{}:{}", year, month, day, hour, min, sec);
    }

    /**
     * 要求外部订单号必须唯一。
     *
     * @return {String}
     */
    public synchronized static String getOutTradeNo() {
        SimpleDateFormat format = new SimpleDateFormat("MMddHHmmss", Locale.getDefault());
        Date date = new Date();
        String key = format.format(date);
        Integer ran = (int) ((Math.random() * 9 + 1) * 100000);
        key = key + ran.toString();
        //	key = key.substring(0, 24);
        return key;
    }


    private static String setTimeStr(String timeStr) {
        if (timeStr.length() == 1) {
            timeStr = "0" + timeStr;
        }
        return timeStr;
    }

    public static Integer similarity(String carNum1,String carNum2){

        if (carNum1.length() != carNum2.length()){
            return 0;
        }
        else if (carNum1.equals(carNum2)){
            return 1;
        }
        else {
            String simi = StrUtil.similar(carNum1,carNum2,1);
            if (carNum1.length() == 7){
                if (simi.equals("85.7%")){
                    return 1;
                }else {
                    return 0;
                }
            }else {
                if (simi.equals("87.5%")){
                    return 1;
                }else {
                    return 0;
                }
            }
        }
    }

    public static String getParkingTimeStr(Integer time) {

        long sec = 1;
        long min = 60 * sec;
        long day = 24 * min;

        StringBuilder sb = new StringBuilder();

        /*if (time == 1){
            sb.append(String.format("%d分钟", 1));
        }else {*/
            if (time >= day) {
                sb.append(String.format("%d天", time / day));
            }
            long remainder = time % day;

            if (remainder >= min) {
                sb.append(String.format("%d小时", remainder / min));
            }

            remainder = remainder % min;

            if (remainder >= sec) {
                sb.append(String.format("%d分钟", remainder / sec));
            }
      //  }
        return sb.toString();
    }


}
